/* Td 1.0 is a minimal tools-demon far from being optimized - but it's my
first program written in genious 'E' and works fine for me. You can call it
by putting run <nil: >nil: Td in your startup-sequence (!) somewhere
***after*** loadwb or (prefered way) by dragging its icon into wbstartup.
If you find (serious) bugs, mail them to arzheim@goofy.zdv.uni-mainz.de . If
you don't like it get another prog and eat dirt.
*/
MODULE 'workbench/workbench','WB'
MODULE 'exec/ports'
/*MODULE 'exec/nodes'*/
MODULE 'dos/notify'
OPT OSVERSION=37



  DEF myargs:PTR TO LONG,rdargs
  DEF filename[80]:STRING
  DEF myapp_port=NIL:PTR TO mp
  DEF appmsg:PTR TO appmessage,fh=NIL
  DEF lesestring[80]:STRING
  DEF anzahl=0
  DEF dummy=NIL
  DEF i
  DEF mymenarray[6]:ARRAY OF LONG
  DEF commstrarr[5]:ARRAY OF LONG
  DEF raus=NIL
  DEF portsig=NIL
  DEF nreq:PTR TO notifyrequest,sig,task,signal


  PROC main()

  myargs:=[0,0]
  FOR i:=0 TO 4 DO commstrarr[i]:=String(60)

  IF (commstrarr[0]=0) OR (commstrarr[1]=0) OR (commstrarr[2]=0) OR (commstrarr[3]=0) OR (commstrarr[4]=0)
  WriteF('No memory for string-array!\n')
  CleanUp(15)
  ENDIF


  IF rdargs:=ReadArgs('CF=CONFIGFILE,HELP/S',myargs,NIL)

     IF myargs[0]                              /*parse configfile*/
        StrCopy(filename,myargs[0],ALL)
     ELSE
        StrCopy(filename,'s:Td.config',ALL)    /*Default-configfile*/
     ENDIF

     FreeArgs(rdargs)


     IF myargs[1] <> 0                     /*Info &exit*/
        WriteF('\n Td - a minimal tools-demon for WB 2/3.x Tools-Menu\n\nCONFIGFILE may contain upto 5 command-lines of the form:\ntitle!command (as you would type it at the shell-prompt).\nSpecial feature: Td recognizes changes in CONFIGFILE while running and\nchanges menu.\n\nDefault CONFIGFILE is s:Td.config\n')
        CleanUp(5)
     ENDIF

     IF nreq:=New(SIZEOF notifyrequest)     /* memory is cleared */
       sig:=AllocSignal(-1)                /* we want to be signalled */
       IF sig=-1
         WriteF('No signal!\n')
         CleanUp(15)
       ENDIF
       IF myapp_port:=CreateMsgPort()             /*setup Port*/
          task:=FindTask(0)
          nreq.name:=filename
          nreq.flags:=NRF_SEND_SIGNAL
          nreq.port:=task                     /* union port/task */
          nreq.signalnum:=sig                 /*prepare struc for notify */
          portsig:=Or(Shl(1,myapp_port.sigbit),Shl(1,sig))  /*wait for two signals*/
          IF workbenchbase:=OpenLibrary('workbench.library',37)
            menuadd()
            StartNotify(nreq)

            REPEAT
              signal:=Wait(portsig)
              /*WriteF('\d\n',signal)*/
              IF signal = Shl(1,myapp_port.sigbit) /*app-menu-message*/
                appmsg:=GetMsg(myapp_port)
                IF appmsg <> 0
                  IF appmsg.id = 6
                     raus:=1
                  ELSE
                     SystemTagList(commstrarr[appmsg.id],0)
                  ENDIF
                  ReplyMsg(appmsg)
                ENDIF
              ELSE       /*notify-message*/
                menusub() /*remove old menu*/
                menuadd() /*setup new menu*/
              ENDIF
            UNTIL raus <> NIL

            EndNotify(nreq)
            menusub()
            WHILE appmsg:=GetMsg(myapp_port) DO ReplyMsg(appmsg)  /*clear Port*/
            CloseLibrary(workbenchbase)
          ELSE
             WriteF('No WB-Lib!\n')
             CleanUp(15)
          ENDIF
          FreeSignal(sig)
          DeleteMsgPort(myapp_port)
       ELSE
         WriteF('No Port!\n')
         CleanUp(15)
       ENDIF
     ELSE
       WriteF('No memory for notify!\n')
       CleanUp(15)
     ENDIF
  ELSE
    WriteF('Usage: td CF=CONFIGFILE,HELP/S\n')
  ENDIF
ENDPROC





PROC menuadd()
DEF titlestr[60]:STRING
DEF pos

FOR i:=0 TO 5 DO mymenarray[i]:=0             /*initialise*/
anzahl:=0

IF fh:=Open(filename,OLDFILE)
  WHILE (-1<>ReadStr(fh,lesestring)) AND (anzahl<5)
    pos:=InStr(lesestring,'!',0)
    IF pos <> -1
      MidStr(titlestr,lesestring,0,pos)
      RightStr(commstrarr[anzahl],lesestring,EstrLen(lesestring)-pos-1)
      dummy:=AddAppMenuItemA(anzahl,0,titlestr,myapp_port,0)
      mymenarray[anzahl]:=dummy
    ENDIF
    anzahl++
  ENDWHILE
  Close(fh)
ELSE
  WriteF('Can\at access CONFIGFILE!\n')
  CleanUp(10)
ENDIF

IF dummy:=AddAppMenuItemA(6,'Quit','Quit Td',myapp_port,0) /*setup menus*/
   mymenarray[5]:=dummy
ELSE
  WriteF('Can\at setup menus\n')
  CleanUp(15)
ENDIF

ENDPROC




PROC menusub()

FOR i:=0 TO 5
  IF mymenarray[i] <> 0 THEN RemoveAppMenuItem(mymenarray[i])
ENDFOR
WHILE appmsg:=GetMsg(myapp_port) DO ReplyMsg(appmsg)
ENDPROC

'$VER: Td 1.0'              /*Version*/
