/* Zahlenratespiel in E,  1995 Marcel Bennicke */

DEF name[30]:STRING, eingabe[10]:STRING,
  maximal, zufallszahl, geraten, schritt

PROC main()
  WriteF('\c',12)  /* Ausgabe von ASCII 12 lscht
                      Fensterinhalte */

  WriteF('\nHerzlich willkommen zu unserem ')
  WriteF('Zahlenratespiel!\n\n')
  WriteF('Bitte geben Sie Ihren Namen ein: ')
  ReadStr(stdout,name)

  REPEAT /* uere Schleife fr Spielwiederholung */
    schritt:=0  /* Schrittzhler auf Null stellen */

    WriteF('\c',12)
    WriteF('In diesem Spiel werde ich eine Zufalls' +
      'zahl >=1\nermitteln, die Sie raten sollen.' +
      ' Wie gro\ndarf diese Zahl maximal sein?\n\n')

    REPEAT    /* 1.innere Schleife durchlaufen bis */
      WriteF('Eingabe (min. 6): ')  /* Eingabe >=6 */
      ReadStr(stdout,eingabe)
      maximal:=Val(eingabe,NIL)
    UNTIL maximal>=6

    /* die Funktion Rnd(x) liefert eine Zufallszahl
       im Bereich von 0 bis x-1 */
    zufallszahl:=Rnd(maximal)+1
    WriteF('\nJetzt geht\as los...\n\n')

    REPEAT  /* 2. Schleife fr Eingabe der Tips */
      INC schritt  /* Schrittzhler um 1 erhhen */

      WriteF('Bitte geben Sie Ihren Tip ein: ')
      ReadStr(stdout,eingabe)  /*in Zahl umwandeln*/
      geraten:=Val(eingabe,NIL)

      IF geraten>zufallszahl /* Eingabe auswerten */
        WriteF('  Leider zu gro!\n\n')
      ELSEIF geraten<zufallszahl
        WriteF('  Leider zu klein!\n\n')
      ENDIF
    UNTIL geraten=zufallszahl /* bis es stimmt */

    WriteF('\nJa Richtig! Super! Spitze!\n' +
     '\s, Sie haben in \d Schritten die Zahl\n'+
     '\d gefunden!\n\n', name, schritt, zufallszahl)

    WriteF('Wollen Sie noch einmal spielen (j/n)? ')
    ReadStr(stdout,eingabe)
  UNTIL StrCmp(eingabe,'n',ALL) /* beenden, wenn n */
ENDPROC
