/*
 *  $VER: GoldFax.rexx 1.00 (12. November 1995)
 */

/* Dieses ARexx-Skript kann ins Men von GoldEd
   eingetragen werden. Es dient zum Faxen des
   aktuellen Textes.

   Zuerst wird der MultiFaxServer gestartet
   (dieser mu beim Start AKTIV sein, siehe
   Config/Sonstige Einstelluzngen/Server aktiv).
   Danach wird der Text ausgedruckt (d.h.
   umgeleitet in eine FaxDatei). Im Telefonbuch
   lt sich der Empfnger eingeben bzw. auswhlen.

   Bei MultiFax 3.0 mu nach dem Fax der Server
   manuell beendet werden. Unter MultiFax 4.0 wird
   der Server automatisch beendet.                  */

options results
ed_port = address()

/*
 *  Das Skript funktioniert nur, wenn des direkt von
 *  GoldEd aus gestartet wurde. Das wird hier
 *  sichergestellt
 */
if (left( ed_port , length( ed_port )-2) ~= "GOLDED") then
    errexit( "Skript mu von Golded aus gestartet werden!")


/*
 *  Kann bei MultiFax 3.0 weggelassen werden
 */
address command "run <>nil: Multifax:MFRexx"
address command 'waitforport MultiFaxRexx'
if rc > 0 then
    errexit( "MFRexx konnte nicht gestartet werden!" )

/*
 *  Server starten, damit der anschlieende
 *  Druckvorgang in eine Faxdatei umgelenkt wird
 */
address command "run <>nil: Multifax:Server"
address command 'waitforport MultiFaxServer'
if rc > 0 then
    errexit( "Server konnte nicht gestartet werden!" )

/*
 *  Kommando an GoldEd: Alles sofort und ohne
 *  Nachfrage ausdrucken (wird umgeleitet)
 */
'PRINT FORCE ALL'
if rc > 0 then
    errexit( "Fehler beim Fax erstellen!" )

/*
 *  Funktioniert nur bei MultiFax 4.0: Server
 *  nachher wieder beenden.
 */
address command wait 5
address 'MultiFaxRexx' EXITALL
exit 0


/*  errexit <text>
 *
 *  Gibt Text aus und beendet Programm mit
 *  Fehlercode 10
 */
errexit:
arg errtext

say "Fehler:" errtext
if show( p , 'MultiFaxRemServer' ) then
    address 'MultiFaxRexx'  EXITALL
exit 10

