/* Beispiele, wie man Variablen/Konstanten definiert.
   Eine Stringvariable mit Platz fr 10 Zeichen */
DEF name[10]:STRING

/* Eine Stringvariable und zwei LONG-Variablen  */
DEF name[20]:STRING, a, b

/* Lange Zeilen lassen mit einem Komma in der
   nchsten Zeile weiterfhren                  */
DEF name[20]:STRING, a, b,
    hilf[10]:STRING

/* Einfache Konstanten beginnen mit CONST und
   drfen nur auf Grobuchstaben und _ bestehen */
CONST ANZAHL = 10
CONST MAXIMAL = ANZAHL+30,
      SCHRITT = $20, BITS = %1100

/* Fr benannte Aufzhlungen bietet sich ENUM an */
ENUM ROT, GRUEN, BLAU, GELB, LILA, SCHWARZ=20

/* Fr benannte Bits ist SET recht praktisch    */
SET  HIRES, LACE, DUALPLAYFIELD, SUPERHIRES

/* Es lt sich auch sofort ein Wert zuweisen   */
DEF a=4:LONG

/* Ein Feld wird mit ARRAY angelegt             */
DEF tab[20]:ARRAY OF INT

/* Eine Liste wird analog zum Array definiert   */
DEF liste[40]:LIST

